import { createIconToken } from '../components/contract-logo';
import { CONTRACT_TYPE } from '../config/contract';
import { isOfficialChainPK } from '../utils/official-chain';
import { contractStoreUtils } from '../utils/storage';

export async function initChainSubscribe(chain) {
  if (chain.enableGas) {
    // 固定订阅gass合约
    await contractStoreUtils.setSubscribe(chain.chainId, {
      contractType: CONTRACT_TYPE.GAS,
      contractIcon: createIconToken(),
      contractName: 'GAS',
    });
  }
  if (isOfficialChainPK(chain)) {
    // 固定订阅 identity
    await contractStoreUtils.setSubscribe(chain.chainId, {
      contractType: CONTRACT_TYPE.CMID,
      contractIcon: createIconToken(),
      contractName: 'identity',
    });
  }
}
